$(document).ready(function() {
  // <ui-layout>
  $('form').layout({
    north: {
      closable: "false",
      spacing_open: 0,
      size: 90,
    },
    center: {
      closable: "false",
      spacing_open: 0,
    },
    south: {
      closable: "false",
      spacing_open: 0,
    },
    west: {
      closable: "false",
      spacing_open: 0,
      size: 200,
    },
  });
  setTimeout(function() { $('.cover').hide(); }, 500);
  // </ui-layout>

  // <navigation>
  $('.createButton').on('click', function(e) {
    e.preventDefault();
    $('.createDropDown').slideToggle('fast');
    $(this).toggleClass('active');
  });
  $('.settingsButton').on('click', function(e) {
    e.preventDefault();
    $('.settingsDropDown').slideToggle('fast');
    $(this).toggleClass('active');
  });
  $('.moreButton').on('click', function(e) {
    e.preventDefault();
    $('.moreDropDown').slideToggle('fast');
    $(this).toggleClass('active');
  });
  $(document).on('click', function(e) {
    if($(e.target).closest('.popupBlock, .buttonPopup').length) return;
    $('.popupBlock').slideUp();
    $('.buttonPopup:not(.moreFile)').removeClass('active');
    e.stopPropagation();
  });
  var createDropDownOffsetTop = 40;
  var menuDropDownOffsetTop = 20;
  var menuArrowWidth = 26;
  $('.settingsButton').css('width', $('.settingsButton span').width() + menuArrowWidth);
  $('.settingsButton').css('background-position', $('.settingsButton span').width() + 2 + 'px 6px');
  $('.moreButton').css('width', $('.moreButton span').width() + menuArrowWidth);
  $('.moreButton').css('background-position', $('.moreButton span').width() + 2 + 'px 6px')
  $('.createDropDown').css('left', $('.createButton').offset().left);
  $('.createDropDown').css('top', $('.createButton').offset().top + createDropDownOffsetTop);
  $('.createDropDown').css('min-width', $('.createButton').width() + 34);
  $('.settingsDropDown').css('left', $('.settingsButton').offset().left);
  $('.settingsDropDown').css('top', $('.settingsButton').offset().top + menuDropDownOffsetTop);
  $('.settingsDropDown').css('min-width', $('.settingsButton').width());
  $('.moreDropDown').css('left', $('.moreButton').offset().left);
  $('.moreDropDown').css('top', $('.moreButton').offset().top + menuDropDownOffsetTop);
  $('.moreDropDown').css('min-width', $('.moreButton').width());
  // </navigation>

  // <settings>
  $('.settingsNavigation li').on('click', function() {
    location.href = $(this).children('a').attr('href');
  });
  var headArrowWidth = 26;
  var selectArrowWidth = 46;
  $('.settingsGroup .head a').each(function() {
    $(this).css('width', $(this).children('span').width() + headArrowWidth);
    $(this).css('background-position', $(this).children('span').width() + 4 + 'px 0px');
  });
  $('select:not(.special)').each(function() {
    $(this).css('width', $(this).width() + selectArrowWidth);
    $(this).css('background-position', $(this).width() - 12 + 'px center');
  });
  $('.updateButton').on('click', function() {
    $(this).siblings('.updateButton').children('input').remove();
    $('body>form')[0].submit();
  });
  $('.restoreButton').on('click', function(e) {
    e.preventDefault();
    $('body>form')[0].reset();
  });
  $('.settingsRestoreDefault').on('click', function(e) {
    e.preventDefault();
    $('body>form')[0].reset();
  });
  $('.settingsGroup .head a').on('click', function(e) {
    e.preventDefault();
    $(this).toggleClass('active');
    $(this).parent().siblings('.body').slideToggle('fast');
  });
  $('.settingsGroup .head a').trigger('click');
  // </settings>

  // <roster>
  $('.rosterTable a[href="#"]').on('click', function(e) {
    e.preventDefault();
    $(this).parent().parent().parent().parent().parent().parent().siblings().find('input[type="hidden"]').val('');
    $('body>form')[0].submit();
  });
  // </roster>
  // <cloned input>
  $('.clone').on('change', function() {
    $(this.nodeName + '[name="' + this.name + '"]').val(this.value);
  });
  // </cloned input>
  $('.overlayBlock .cancelButton, .overlayBlock .topPanelContainer img').on('click', function() {
    $('.overlayBlock').hide();
    $('form > .mainPanelContainer > *').css('opacity', 1);
  });
  // <logout img>
  $('.naviUser a').hover(
    function() {
      $(this).children('img[src="logout.png"]').hide();
      $(this).children('img[src="logout_hover.png"]').show();
    },
    function() {
      $(this).children('img[src="logout_hover.png"]').hide();
      $(this).children('img[src="logout.png"]').show();
    }
  );
  // </logout img>
  // <subscription>
  $('#showSubscriptions').on('click', function(e) {
    e.preventDefault();
    $('.subscription .mainPanelContent').load(
      'Subscription.wssp',
      function() {
        $('.subscription .restoreButton, .subscription .updateButton').off('click');
        $('.subscription .restoreButton').on('click', function(e) {
          e.preventDefault();
          $('#showSubscriptions').trigger('click');
        });
        $('.subscription .updateButton').on('click', function(e) {
          e.preventDefault();
          var subscriptionData = {};
          var Elem = new Array();
          var AliasName = new Array();
          $('.subscription input').each(function() {
            if($(this).attr('name') == 'AliasName') AliasName.push($(this).val());
            else if($(this).attr('name') == 'Elem') Elem.push($(this).val());
            else subscriptionData[$(this).attr('name')] = $(this).val();
          });
          var ElemStr = '';
          var AliasNameStr = '';
          for(var i = 0; i < Elem.length; i++) ElemStr += 'Elem=' + Elem[i] + '&';
          for(var i = 0; i < AliasName.length; i++) AliasNameStr += 'AliasName=' + AliasName[i] + '&';
          var query = $.param(subscriptionData).replace(/%5B%5D/g, '');
          query = query.replace(/\+/g, '%20');
          $.get(
            'Subscription.wssp?' + ElemStr + AliasNameStr + query,
            function(data) {
              if($(data).find('span.failureText').length) {
                var errorText = $(data).find('span.failureText').text();
                alert(errorText);
              } else {
                location.href = 'settings5.wssp';
              }
            }
          );
        });
        showOverlayBlock('.subscription');
      }
    );
  });
  // </subscription>
});

function getParameterByName(name) {
  name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
  var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
  results = regex.exec(location.search);
  return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

function showOverlayBlock(selector) {
  $('.overlayBlock').hide();
  $('form > .mainPanelContainer > *').css('opacity', '0.1');
  $(selector).css('top', 90);
  $(selector).css('left', 210);
  var w_corr = -210;
  if(selector == '.subscription') w_corr = -5;
  $(selector).css('width', $('form > .mainPanelContainer').width() + w_corr);
  var height = $('.copyright').offset().top - 120;
  $(selector).css('height', height);
  $(selector).show();
}

function sendShareNotification(user, name, to, request, text) {
  $.post(
    'aclnotification.wcgp',
    {
      user: user,
      name: name,
      to: to,
      request: request,
      text: text,
    }
  );
}

