function loadCalendar(params) {
  var query = $.param(params).replace(/%5B%5D/g, '');
  query = query.replace(/\+/g, '%20');
  $('#pane-center').load(
    'Calendar.wssp?' + query,
    function() {
      var mailboxName = $('input[name="mailbox"]').val();
      $('#pane-center').scrollTop(0);
      $('#pane-center').css('width', 'auto');
      var calendarView = $('input[name="calendarView"]').val() || 'Table';
      if(!urlParams.schedule) $('.calendarNavigation .' + calendarView).addClass('active');
      else $('.calendarNavigation .Table').addClass('active');
      $('.calendarView').on('click', function() {
        if($(this).hasClass('Folder')) {
          location.href = 'Hello.wssp?center=loadMailbox&Mailbox=' + encodeURIComponent(mailboxName);
          return;
        }
        var todayDayNum = $('input[name="todayDayNum"]').val();
        var view = $(this).attr('class').split(/\s/)[1];
        if(view == 'Table') {
          urlParams.schedule = 1;
          view = 'Monthly';
        } else {
          delete urlParams.schedule;
        }
        urlParams.calendarView = view;
        urlParams.JumpDay = todayDayNum;
        var query = $.param(urlParams).replace(/%5B%5D/g, '').replace(/\+/g, '%20');
        location.href = 'Hello.wssp?' + query;
      });
      initSettings(mailboxName);
      var prev = $('#prev').val();
      var next = $('#next').val();
      var sch = urlParams.schedule ? 1 : '';
      if(sch) {
        $('.monthlyCalendar').hide();
        $('.scheduleCalendar').show();
        $('.moreContainer').show();
        $('#later').on('click', function(e) {
          e.preventDefault();
          var later = $(this);
          var counter = 12;
          getLater(later, mailboxName, counter);
        });
      }
      $('.leftPrevArrow').on('click', function() {
        location.href =
          'Hello.wssp?center=loadCalendar&Mailbox=' + encodeURIComponent(mailboxName) + '&JumpDay=' + prev + '&schedule=' + sch;
      });
      $('.rightNextArrow').on('click', function() {
        location.href =
          'Hello.wssp?center=loadCalendar&Mailbox=' + encodeURIComponent(mailboxName) + '&JumpDay=' + next + '&schedule=' + sch;
      });
      var locale = $('html').attr('lang');
      $.datepicker.regional['ru'] = {
        monthNames: ['Январь','Февраль','Март','Апрель','Май','Июнь','Июль','Август','Сентябрь','Октябрь','Ноябрь','Декабрь'],
        monthNamesShort: ['Янв','Фев','Мар','Апр','Май','Июн','Июл','Авг','Сен','Окт','Ноя','Дек'],
        dayNames: ['воскресенье','понедельник','вторник','среда','четверг','пятница','суббота'],
        dayNamesShort: ['вск','пнд','втр','срд','чтв','птн','сбт'],
        dayNamesMin: ['Вс','Пн','Вт','Ср','Чт','Пт','Сб'],
      };
      $('#datepicker').datepicker({ firstDay: 1, dateFormat: 'yy-mm-dd', });
      if(locale == 'ru') $('#datepicker').datepicker("option", $.datepicker.regional[locale]);
      $('.datepickerLink').on('click', function(e) {
        e.preventDefault();
        $('#datepicker').trigger('focus');
      });
      $('#ui-datepicker-div').addClass('popupEsc');
      $('#datepicker').on('change', function() {
        var date = new Date($(this).val());
        var jumpDay = (date.getTime()/86400000).toFixed();
        urlParams.JumpDay = jumpDay;
        var query = $.param(urlParams).replace(/%5B%5D/g, '').replace(/\+/g, '%20');
        location.href = 'Hello.wssp?' + query;
      });
      if(calendarView != 'Daily') initCalendarClick();
    }
  );
}

function getLater(later, mailboxName, counter) {
  $.get(
    'Calendar.wssp',
    {
      Mailbox: mailboxName,
      calendarView: 'Monthly',
      JumpDay: later.attr('data-value'),
    },
    function(data) {
      counter--;
      later.attr('data-value', $(data).find('#next').val());
      var tbody = $(data).find('.scheduleCalendar > tbody');
      if(tbody.length) $('.scheduleCalendar').append(tbody.html());
      else if(counter) {
        getLater(later, mailboxName, counter);
      }
    }
  );
}

function initCalendarClick() {
  var ph = 200 + 10;
  var pw = 440 + 20;
  var fxh = 100;
  $('.day').each(function() {
    var height = $(this).height() - $(this).find('.date').height() - $(this).find('.eventList').height() - 20;
    if(height > 0) {
      if($(this).height() > fxh) $(this).find('.clickable').height(height);
      else {
        height = height + (fxh - $(this).height());
        $(this).find('.clickable').height(height);
      }
    }
    else /*if(!$(this).find('.eventList li').length)*/ $(this).find('.clickable').height(fxh - $(this).height() - 2);
  });
  $('.monthlyCalendar > tbody .date, .weeklyCalendar .date, .clickable').on('click', function() {
    $('.selectedDay').removeClass('selectedDay');
    $('.eventList li.active').removeClass('active');
    $(this).parents('.day').addClass('selectedDay');
    var date = $(this).attr('data-value');
    $('#newEvent').remove();
    $('#infoEvent').remove();
    $('#container').append(
      '<div id="newEvent" class="dialog popupEsc">' +
        '<div class="topPanelContainer">' +
          '<span class="newType">' + strings.event + '</span>' +
          '<img class="right close" src="greylogout.png" />' +
        '<table class="eventForm" width="100%" cellspacing="0" cellpadding="0" border="0">' +
        '<tr><td width="50%" nowrap="nowrap">' + date + '</td>' +
          '<td align="center" width="50%">' +
        '<span class="select_EventStartTime customSelect buttonPopup">' +
          '<img src="folder_tasks.gif" alt="" /><span></span>' +
        '</span>' +
        '</td></tr>' +
        '<tr><td>' + strings.subject + '</td>' +
        '<td align="right"><input type="text" id="newEventName" size="20" style="width:300px" /></td></tr>' +
        '</table>' +
        '</div>' +
        '<table width="100%" class="buttonContainer" cellspacing="0" cellpadding="0"><tr>' +
          '<td width="50%" align="center"><a href="#" class="create">' + strings.create + '</a></td>' +
          '<td width="50%" align="center"><a href="#" class="edit">' + strings.edit + '</a></td>' +
        '</tr></table>' +
        '<ul class="eventStartTimeDropDown popupBlock"></ul>' +
      '</div>'
    );
    var pt = $(this).offset().top;
    var pl = $(this).offset().left;
    if((pt - ph) > 0) $('#newEvent').css('top', pt - ph);
    else $('#newEvent').css('top', pt);
    if(($('#container').width() - pl) > pw) $('#newEvent').css('left', pl);
    else $('#newEvent').css('left', pl - pw);
    $('#newEvent').show();
    $('#newEvent img.close').on('click', function(e) {
      e.preventDefault();
      $('.selectedDay').removeClass('selectedDay');
      $('#newEvent').remove();
    });
    $('#newEvent .edit').on('click', function(e) {
      e.preventDefault();
      var startTime = $('#newEventTimeHH').val() * 3600 + $('#newEventTimeMM').val() * 60;
      location.href = 'Compose.wssp?IsEvent=1&origMailbox=' + encodeURIComponent(urlParams.Mailbox) + '&subject=' + 
        encodeURIComponent($('#newEventName').val()) + '&EventStartDate=' + encodeURIComponent(date) + '&EventStartTime=' + startTime;
    });
    $('#newEvent .create').on('click', function(e) {
      e.preventDefault();
      var startTime = $('select[name="EventStartTime"]').val();
      var startDate = date.substring(6,10) + date.substring(3,5) + date.substring(0,2);
      $.post(
        'Compose.wssp',
        {
          isEvent: 1,
          Subject: $('#newEventName').val(),
          EventStartTime: startTime,
          EventStartDate: startDate,
          origMailbox: urlParams.Mailbox,
          filled: 1,
          Save: 1,
        },
        function(data) {
          if($(data).find('span.failureText').length) {
            var errorText = $(data).find('span.failureText').eq(0).text();
            alert(errorText);
          } else {
            var query = $.param(urlParams).replace(/%5B%5D/g, '').replace(/\+/g, '%20');
            location.href = 'Hello.wssp?' + query;
          }
        }
      );
    });
    // <starttime>
    var sts = $('.select_EventStartTime');
    if(sts.length) {
      sts.children('span').text($('select[name="EventStartTime"] option:selected').text());
      $('select[name="EventStartTime"] option').each(function() {
        $('.eventStartTimeDropDown').append('<li title="' + $(this).val() + '">' + $(this).text() + '</li>');
      });
      sts.on('click', function(e) {
        e.preventDefault();
        $('.eventStartTimeDropDown').slideToggle();
      });
      $('.eventStartTimeDropDown').css('min-width', 85);
      $('.eventStartTimeDropDown').css('height', 173);
      $('.eventStartTimeDropDown').css('left', 239);
      $('.eventStartTimeDropDown').css('top', -16);
      $('.eventStartTimeDropDown li').on('click', function() {
        sts.children('span').text($(this).text());
        $('select[name="EventStartTime"]').val($(this).attr('title'));
        $('.popupBlock').slideUp('fast');
      });
    }
    // </starttime>
  });
  $('.eventList li').on('click', function(e) {
    e.preventDefault();
    var MSG = $(this).attr('data-value');
    var date = $(this).parent().parent().parent().parent().find('.date').attr('data-value');
    var time = ', ' + $(this).children('a').attr('data-value');
    $('.selectedDay').removeClass('selectedDay');
    //$(this).parents('.day').addClass('selectedDay');
    $('.eventList li.active').removeClass('active');
    if(!$(this).hasClass('active')) $(this).addClass('active');
    $('#newEvent').remove();
    $('#infoEvent').remove();
    $('#container').append(
      '<div id="infoEvent" class="dialog popupEsc">' +
        '<div class="topPanelContainer">' +
          date + time + '<img class="right close" src="greylogout.png" />' +
        '<p>' + $(this).children('a').attr('title') + '</p>' +
        '</div>' +
        '<table class="buttonContainer" width="100%" cellspacing="0" cellpadding="0"><tr>' +
          '<td width="50%" align="center"><a href="#" class="delete">' + strings.deletestr + '</a></td>' +
          '<td width="50%" align="center">' +
            '<a href="' + $(this).children('a').attr('href') + '" class="edit">' + strings.edit + '</a>' +
          '</td>' +
        '</tr></table>' +
      '</div>'
    );
    var pt = $(this).offset().top;
    var pl = $(this).offset().left;
    if((pt - ph) > 0) $('#infoEvent').css('top', pt - ph);
    else $('#infoEvent').css('top', pt);
    if(($('#container').width() - pl) > pw) $('#infoEvent').css('left', pl);
    else $('#infoEvent').css('left', pl - pw);
    $('#infoEvent').show();
    $('#infoEvent img.close').on('click', function(e) {
      e.preventDefault();
      $('.selectedDay').removeClass('selectedDay');
      $('#infoEvent').remove();
    });
    $('#infoEvent .delete').on('click', function() {
      if(confirm(strings.deletestr + ' ' + strings.event + '?')) {
        $.get(
          'Mailbox.wssp',
          {
            Mailbox: urlParams.Mailbox,
            MSG: MSG,
            Delete: 1,
          },
          function(data) {
            if($(data).find('span.failureText').length) {
              var errorText = $(data).find('span.failureText').eq(0).text();
              alert(errorText);
            } else {
              var query = $.param(urlParams).replace(/%5B%5D/g, '').replace(/\+/g, '%20');
              location.href = 'Hello.wssp?' + query;
            }
          }
        );
      }
    });
  });
}

