$(function() {
  //setTimeout(function() { location.replace('Conftest.wssp'); }, 120 * 1000);
  var serverName = location.hostname;
  var serverPort = location.port;
  var sessionID = $('#sessionID').val();
  createSession(serverName,serverPort,userName,sessionID);
  updateControls();
  $('#unholdConf').hide();
  window.onbeforeunload = function() { closeSession(); }
  window.onunload = function() { closeSession(); }
  window.onclose = function() { closeSession(); }
  $('#startConf').on('click', function(e) {
    e.preventDefault();
    if(!isStarted()) startConference();
    updateControls();
  });
  $('#stopConf').on('click', function(e) {
    e.preventDefault();
    if(isStarted()) stopConference();
    updateControls();
  });
  $('#inviteParty').on('click',function(e) {
    e.preventDefault();
    var partyExt = $('#partyExt').val();
    if(partyExt != '') {
      var extList = partyExt.split(',');
      extList.forEach(function(ext) {
        inviteParty(ext);
      });
      $('#partyExt').val('');
    }
  });
  $('#holdConf').on('click', function(e) {
    e.preventDefault();
    triggerMusic();
    $(this).hide();
    $('#unholdConf').show();
  });
  $('#unholdConf').on('click', function(e) {
    e.preventDefault();
    triggerMusic();
    $(this).hide();
    $('#holdConf').show();
  });
  $('#connectMe').on('click', function(e) {
    e.preventDefault();
    inviteParty('self');
    updateControls();
  });
  $('#muteAll').on('click', function(e) {
    e.preventDefault();
    $('.muteParty').trigger('click');
  });
  $('#unmuteAll').on('click', function(e) {
    e.preventDefault();
    $('.unmuteParty').trigger('click');
  });
  $('html').on('reportReceived',function(eventObj,report) {
    var partiesInfo = parseReport(report);
    updateParties(partiesInfo);
    $('.disconnectParty').on('click',function(e) {
      e.preventDefault();
      if($(this).parent().siblings('td:contains("' + userName + '")')) $('#connectMe').show();
      disconnectParty($(this).attr('id').substr(8));
      $(this).parent().parent().remove();
    });
    $('.muteParty').on('click', function(e) {
      e.preventDefault();
      muteParty($(this).attr('id').substr(8));
    });
    $('.unmuteParty').on('click', function(e) {
      e.preventDefault();
      unmuteParty($(this).attr('id').substr(8));
    });
  });
  $('#address select').on('change', function() {
    $.get(
      "Compose.wssp",
      {
        addressBook: 1,
        selectedAddressBook: $(this).val(),
      },
      function(data) {
        var o = $.parseJSON(data);
        var list = o.list;
        list.length = list.length - 1;
        var result = '';
        var name;
        var mail;
        for(var i = 0; i < list.length; i++) {
          name = list[i].replace(/^(.*)\s&lt;.*&gt;$/, "$1");
          mail = list[i].replace(/^.*\s&lt;(.*)&gt;$/, "$1");
          result += '<li><table width="100%" border="0" cellpadding="0" cellspacing="0"><tr>' +
            '<td class="name" align="left">' + name + '</td>' +
            '<td class="mail" align="right">' + mail + '</td></tr></table></li>';
        }
        $('#address .mainPanelContent').html(result);
        $('#address .mainPanelContent li').on('click', function() {
          $('#partyExt').val($(this).find('.mail').text());
        });
      }
    );
  });
  var top_corr = -80;
  //if(/webkit/i.test(navigator.userAgent)) top_corr = 0;
  $(window).on('resize', function() {
    $('#address ul').css(
      'height',
      $(window).height() - $('.ui-layout-north').height() - $('.ui-layout-south').height() - $('#address .topPanelContainer').height() + top_corr
    );
  });
  $(window).trigger('resize');
  $('#address select').trigger('change');
  $('#filterAddress').val('');
  $('#address li').show();
  jQuery.expr[":"].Contains = jQuery.expr.createPseudo(function(arg) {
    return function( elem ) {
      return jQuery(elem).text().toUpperCase().indexOf(arg.toUpperCase()) >= 0;
    };
  });
  $('#filterAddress').on('keyup', function() {
    if(this.value.replace(/\s/g).length) {
      $('#address li:Contains("' + this.value + '")').show();
      $('#address li:not(li:Contains("' + this.value + '"))').hide();
    }
    else $('#address li').show();
  });
});
function updateControls() {
  setTimeout(function() {
    if(isStarted()) setStarted();
    else setStopped();
  },500);
}
function setStopped() {
  $('#ownerContainer').hide();
  $('#partyContainer').hide();
  $('#addPartyContainer').hide();
  $('#stopConf').hide();
  $('#holdConf').hide();
  $('#unholdConf').hide();
  $('#address').hide();
  $('#startConf').show();
}
function setStarted() {
  $('#ownerContainer').show();
  $('#partyContainer').show();
  $('#addPartyContainer').show();
  $('#stopConf').show();
  $('#holdConf').show();
  $('#address').show();
  $('#startConf').hide();
}
function updateParties(partiesInfo) {
  if(partiesInfo.length < 1) {
    $('#muteAll').hide();
    $('#unmuteAll').hide();
    return;
  }
  $('#partyContainer tbody').html('');
  $('#muteAll').show();
  $('#unmuteAll').show();
  var id, address, state, errorCode, isAttendee;
  for(var i = 0; i < partiesInfo.length; i++) {
    if(partiesInfo[i].id != null) {
      id = partiesInfo[i].id;
      address = partiesInfo[i].address;
      state = partiesInfo[i].state;
      errorCode = partiesInfo[i].errorCode;
      if(!state && !errorCode) state = 'online';
      if(address == 'self' || address == userName) {
        address = userName;
        $('#connectMe').hide();
        isAttendee = true;
      }
      var isMuted = /^mute$/.test(state) ? true : false;
      $('#partyContainer tbody').append(
        '<tr' + (isMuted ? ' class="greyDarkBack"' : '') + '><td>' + address + '</td><td>' + state + '</td>' +
        '<td><a href="#" class="' + (isMuted ? 'unmuteParty' : 'muteParty') + '" id="partyID_' + id + '">' +
          (isMuted ? unmuteTag : muteTag) + '</a></td>' +
        '<td><a href="#" class="disconnectParty" id="partyID_' + id + '">' + deleteTag + '</a></td></tr>'
      );
    }
  }
  if(!isAttendee) $('#connectMe').show();
}
function parseReport(node) {
  var result = new Array;
  for(var i=0; i<node.childNodes.length; i++) {
    var party = {};
    for(var j=0; j<node.childNodes[i].childNodes.length; j++)
      party[node.childNodes[i].childNodes[j].attributes[0].textContent] = node.childNodes[i].childNodes[j].textContent;
    result.push(party);
  }
  return result;
}

