function XIMSSController() {
  var that = this;
  var ximssSession = null;

  function ximssAsyncProcessor(xmlResponse) {
    console.log('S: ximssAsyncProcessor');
    console.log(xmlResponse);
  }
  function ximssNetworkErrorProcessor(isFatal,timeElapsed) {
    console.log(isFatal ? 'fatal' : 'having problems for ' + timeElapsed + ' sec');
  }
  function readRosterItemResponse(xmlData) {
    // do smth
  }
  function loginCallback(newSession,errorCode) {
    if(errorCode != null) {
      console.log('S: loginCallback');
      console.log(errorCode);
      closeSession();
      return;
    }
    ximssSession = newSession;
    ximssSession.setUnknownAsyncProcessor(that,ximssAsyncProcessor);
    ximssSession.setNetworkErrorProcessor(that,ximssNetworkErrorProcessor);
    //ximssSession.setAsyncProcessor(that,readRosterItemResponse,'rosterItem');
    ximssSession.start();
    getRosterList();
    // set presence
    // signalBind
    return;
  }
  function logoutCallback(errorCode,xmlRequest) {
    if(errorCode != null) {
      console.log('S: logoutCallback');
      console.log(errorCode);
      console.log(xmlRequest);
    }
  }
  function dataCallback(xmlData,xmlRequest) {
    console.log('S: dataCallback');
    console.log(xmlData);
  }
  function rosterItemCallback(xmlData) {
    addRosterListItem(xmlData.getAttribute('name'));
  }
  function finalCallback(errorCode,xmlRequest) {
    if(errorCode != null) {
      console.log('S: finalCallback');
      console.log(errorCode);
      console.log(xmlRequest);
    }
  }

  this.createSession = function(serverAddress,userName,sessionID) {
    var params = new Object;
    params.binding = 'HTTP';
    if(location.href.substr(0,6) == 'https:') params.secureMode = 'YES';
    params.serverName = serverAddress;
    params.loginMethod = 'sessionid';
    params.userName = userName;
    params.sessionid = sessionID;
    params.pollPeriod = 20;
    new XIMSSSession(params,this,loginCallback);
    return;
  }
  this.closeSession = function() {
    if(ximssSession != null) {
      ximssSession.close(that,logoutCallback);
    }
  }
  this.sendRequest = function(request,params,data) {
    if(ximssSession == null) {
      alert('ximssSession does not exist');
      return;
    }
    xmlRequest = ximssSession.createXMLNode(request);
    xmlRequest.setAttribute('report','xml');
    if(params != null) {
      for (var attr in params) {
        xmlRequest.setAttribute(attr,params[attr]);
      }
    }
    if(data != null) {
      xmlRequest.appendChild(ximssSession.createTextNode(data));
    }
    console.log('C:');
    console.log(xmlRequest);
    ximssSession.sendRequest(xmlRequest,that,dataCallback,finalCallback,true);
  }
  function getRosterList() {
    if(ximssSession == null) {
      alert('ximssSession does not exist');
      return;
    }
    xmlRequest = ximssSession.createXMLNode('rosterList');
    xmlRequest.setAttribute('report','xml');
    console.log('C:');
    console.log(xmlRequest);
    ximssSession.sendRequest(xmlRequest,that,rosterItemCallback,finalCallback,true);
  }
}

var myController = null;

function createSession(serverName,serverPort,userName,sessionID) {
  if(myController == null) {
    var serverAddress = serverName;
    if(serverPort != null) serverAddress += ':' + serverPort;
    myController = new XIMSSController();
    myController.createSession(serverAddress,userName,sessionID);
  } else console.log('D: createSession');
}
function closeSession() {
  if(myController != null) {
    myController.closeSession()
  } else console.log('D: closeSession');
}
function addRosterListItem(peer) {
  if(peer && peer != '') $('#rosterList').append('<div class="rosterListItem">' + peer + '</div>');
}
